#ifndef CHIP_CLK_H
#define CHIP_CLK_H

#include "chip_std_defs.h"
#include "chip_clk_ids.h"
#include "chip_cfg_defs.h"




#define CHIP_CLK_CPU_INITIAL_FREQ   CHIP_MHZ(4)

#define CHIP_CLK_HFRC_FREQ          CHIP_MHZ(32)
#define CHIP_CLK_LFRC_FREQ          CHIP_KHZ(32)
#define CHIP_CLK_HFRC_DIV16_FREQ    (CHIP_MHZ(32)/16)

#define CHIP_CLK_OSC_HF_FREQ_MAX    CHIP_MHZ(32)
#define CHIP_CLK_OSC_HF_FREQ_MIN    CHIP_KHZ(400)
#define CHIP_CLK_OSC_LF_FREQ_MIN    CHIP_KHZ(32)



#define CHIP_CLK_WDT_SRC_ID   CHIP_CLK_ID_VAL(CHIP_CLK_WDT_SRC)
#if CHIP_CLK_WDT_SRC_ID == CHIP_CLK_HFRC_DIV16_ID
    #define CHIP_CLK_WDTSRC_FREQ CHIP_CLK_HFRC_DIV16_FREQ
    #define CHIP_CLK_WDTSRC_EN   CHIP_CLK_HFRC_DIV16_EN
#elif CHIP_CLK_WDT_SRC_ID == CHIP_CLK_LFRC_ID
    #define CHIP_CLK_WDTSRC_FREQ CHIP_CLK_LFRC_FREQ
    #define CHIP_CLK_WDTSRC_EN   CHIP_CLK_LFRC_EN
#else
    #define CHIP_CLK_WDTSRC_FREQ 0
    #define CHIP_CLK_WDTSRC_EN   0
#endif




#define CHIP_CLK_SYS_SRC_ID   CHIP_CLK_ID_VAL(CHIP_CLK_SYS_SRC)
#if CHIP_CLK_SYS_SRC_ID == CHIP_CLK_HFRC_ID
    #define CHIP_CLK_SYSSRC_FREQ    CHIP_CLK_HFRC_FREQ
    #define CHIP_CLK_SYSSRC_EN      CHIP_CLK_HFRC_EN
#elif CHIP_CLK_SYS_SRC_ID == CHIP_CLK_LFRC_ID
    #define CHIP_CLK_SYSSRC_FREQ    CHIP_CLK_LFRC_FREQ
    #define CHIP_CLK_SYSSRC_EN      CHIP_CLK_LFRC_EN
#elif CHIP_CLK_SYS_SRC_ID == CHIP_CLK_OSC_ID
    #define CHIP_CLK_SYSSRC_FREQ    CHIP_CLK_OSC_FREQ
    #define CHIP_CLK_SYSSRC_EN      CHIP_CLK_OSC_EN
#else
    #define CHIP_CLK_SYSSRC_FREQ    0
    #define CHIP_CLK_SYSSRC_EN      0
#endif

#define CHIP_CLK_SYS_FREQ           (CHIP_CLK_SYSSRC_FREQ/CHIP_CLK_SYS_DIV)
#define CHIP_CLK_SYS_EN             CHIP_CLK_SYSSRC_EN

#define CHIP_CLK_CPU_FREQ           CHIP_CLK_SYS_FREQ



#endif // CHIP_CLK_H
